// Craig S. Kaplan
// A quick demonstration of setting up a "speed reading"
// style display of text.  Create a big array of all the
// individual words in a piece of text, and display them
// one-by-one at high speed.

String[] words = new String[0];
int index = 0;

void setup()
{
  size( 400, 200 );
  textSize( 50 );
  textAlign( CENTER );
  fill( 255 );
  
  // Get the text from the external file, in a line-by-line
  // array of strings.
  String[] lines = loadStrings( "marley.txt" );
  
  // Walk over the lines.  Take each line apart into its words
  // and glue it onto the array containing all the words in the
  // text.
  for( int idx = 0; idx < lines.length; ++idx ) {
    String[] new_words = splitTokens( lines[idx] );
    words = concat( words, new_words );
  }
  
  frameRate( 8 );
}

void draw()
{
  background( 80 );
  
  // Display the current word and then increment the
  // index so that the next time you draw you'll get the
  // next word in the array.
  text( words[index], width/2, height/2 );
  index = (index + 1) % words.length;
}